	;; Gorf Complete Memory Diagnostics
	;; @ 2006 Mark Spaeth
	;; mspaeth@gmail.com
	;;
	;; All righte reserved
	;; Not for resale
	;; Paypal donations welcome!
	;; 
	;; Font borrowed from Dave Turner
	;; cmdr-dave@spamcop.net
	;; 
	
	;;      DRAM :	  0x4000-0x7fff
	;;  
	;; Gorf  ROM :	  0x0000-0x3fff
	;;		  0x8000-0xbfff
	;; Gorf SRAM :	  0xd000-0xdfff
	;;
	;; Roto  ROM :	  0x0000-0x3fff
	;;		  0x8000-0xdfff
	;; Roto SRAM :	  0xe000-0xffff

	
	org	0x0000

reset
	di

inithw
	xor	a
	ld	i,a			; Interrupt page 
	im	2			; Interrupt mode (not that we'll use them...)
	out	(0x0e),a		; Disable astrocade interrupts
	inc	a
	out	(0x08),a		; Set high-res video 
	ld	a,0x2c
	out	(0x09),a		; Set video color/mode
	ld	a,0xcc
	out	(0x0a),a		; Screen height = 204 lines 
	ld	hl,coltbl
	ld	b,0x08			; Byte count	
	ld	c,0x0b			; Color table port 
	otir				; Write colortable
	;; 	ld	a,0xca
	;; 	out	(0x0d),a		; Interrupt vector ?
	;; 	ld	a,0xca
	;; 	out	(0x0f),a		; Screen interrupt line ?
	in	a,(0x10)		; Kick Watchdog

	ld	ix,dotitle
	jp	clrscn

dotitle
	ld	a,0x0c
	out	(0x19),a		; Color = Red
	ld	a,0x08
	out	(0x0c),a		; Expand mode 
	ld	hl,title
	ld	ix,titledone
	jp	drawstring
titledone
	
	;; 	ld	hl,version	
	ld	ix,versiondone
	jp	drawstring
versiondone

	;;	ld	hl,oopyrt
	ld	ix,copyrtdone
	jp	drawstring
copyrtdone
	
	;; 	ld	hl,email
	ld	ix,emaildone
	jp	drawstring
emaildone

	;; 	ld	hl,sram
	ld	ix,ssramdone
	jp	drawstring
ssramdone

	;; 	ld	hl,line
	ld	ix,linedone
	jp	drawstring
linedone

sramspin
	in	a,(0x10)		; Kick watchdog
	in	a,(0x12)		; Check P1 controls 
	bit	4,a			; Fire button 
	jp	nz,sramspin

	;;	ld	hl,sramruns
	ld	ix,sramrunsdone
	jp	drawstring
sramrunsdone

	;;	ld	hl,drambadclr
	ld	ix,drambadcdone
	jp	drawstring
drambadcdone
	
sramtest				; Run SRAM Test 
	ld	hl,0xd000		; Start Address 
	ld	bc,0x1020		; 0x10 pages, 0x20 loops
	;; 	ld	bc,0x1001		; 0x10 pages, 0x20 loops 
	ld	ix,srtret
	jp	ramtest
srtret
	;; 	ld	a,0x10		; Test outputs
	;; 	ld	hl,0xd000	; Test outputs
	and	0xff
	jp 	z,sramdone

	;; SRAM Error
sramerr
	;; a & 0x0f  -> X21/23/25/27
	;; a & 0xf0  -> X22/24/26/28
	;; d000-d3ff -> X21/22		1101 00xx 
	;; d400-d7ff -> X23/24		1101 01xx
	;; d800-dbff -> X25/26		1101 10xx
	;; dc00-dfff -> X27/28		1101 11xx
	ld	l,a
	ld	a,h
	and	0x0c
	rrca
	add	a,0x32
	ld	b,a
	ld	a,l
	and	0x0f
	ld	a,0xff
	jp	nz,srseldone
	xor	a
srseldone
	add	a,b			; (a=digit to draw)
	ex	af,af'

	ld	hl,srambad
	ld	ix,srambaddone
	jp	drawstring
srambaddone
	
	;;	ld	hl,srambad2
	ld	ix,srambad2done
	jp	drawstring
srambad2done

	ex	af,af'
	ld	iy,sramokdone
	jp	drawchar


	;; SRAM OK
sramdone
	ld	hl,sramok
	ld	ix,sramokdone
	jp	drawstring
sramokdone
	
	ld	hl,dram
	ld	ix,sdramdone
	jp	drawstring
sdramdone


	;; Spin for start of DRAM test
dramspin
	in	a,(0x10)		; Kick watchdog
	in	a,(0x12)		; Check P1 controls 
	bit	4,a			; Fire button 
	jp	nz,dramspin

dramtest				; Run DRAM Test 
	ld	hl,0x4000		; Start Address
	ld	bc,0x4020		; 0x40 pages, 0x20 loops
	;; 	ld	bc,0x4001		; 0x40 pages, 0x01 loops
	ld	ix,drtret
	jp	ramtest
drtret

	;; 	ld	a,0x20			; Test output
	;; 	ld	hl,0x4002		; Test output
	ex	af,af'
	exx
	ld	ix,dramclsdone
	jp	clrscn
dramclsdone
	
	exx
	ex	af,af'
	and	0xff
	jp 	z,dramdone

dramerr
	;; Only need a,l
	;; a & 0x55   nz	Card 5
	;; a & 0xaa   nz	Card 6
	;; a & 0x03   nz	U4/U8/U12/U16
	;; a & 0x0c   nz	U3/U7/U11/U15
	;; a & 0x30   nz	U2/U6/U10/U14
	;; a & 0xc0   nz	U1/U5/U9/U13
	;; l & 0x03 = 00	U1-4		; 00 -> 00xx 
	;; l & 0x03 = 01	U5-8		; 01 -> 01xx
	;; l & 0x03 = 02	U9-12		; 10 -> 10xx
	;; l & 0x03 = 03	U13-16		; 11 -> 11xx

	ld	h,a		; h unused, stash a 
	and	0x03
	ld	c,0x04
	jp	nz,drecoldone

	ld	a,h
	and	0x0c
	ld	c,0x03
	jp	nz,drecoldone

	ld	a,h
	and	0x30
	ld	c,0x02
	jp	nz,drecoldone

	ld	a,h
	and	0xc0
	ld	c,0x01
drecoldone			; C = chip column
	
	and	0xaa
	ld	a,0x36
	jr	z,drcarddone
	dec	a
drcarddone
	ld	b,a		; B = Card #, ready to print

	ld	a,l
	and	0x03
	rlca
	rlca
	add	a,c
	ld	c,a		; C = Chip #
	cp	0x09
	ld	a,0x06
	jp	nc,drcarry
	xor	a
drcarry
	add	a,c
	ld	c,a

	ld	hl,drambad
	ld	ix,drambaddone
	jp	drawstring
drambaddone
	;; 	ld	hl,drambad2
	ld	ix,drambad2done
	jp	drawstring
drambad2done
	exx
	ld	de,0x19c8
	exx
	ld	a,b
	ld	iy,drdccarddone
	jp	drawchar
drdccarddone

	ld	de,0x2d78
	exx
	ld	a,c
	rrca
	rrca
	rrca
	rrca
	and	0x0f
	or	0x30
	ld	iy,drdcuhdone
	jp	drawchar
drdcuhdone

	;; 	ld	de,0x2d78
	exx
	ld	a,c
	and	0x0f
	or	0x30
	ld	iy,drdculdone
	jp	drawchar
drdculdone
	jp	dotitle

dramdone
	ld	hl,dramok
	ld	ix,dramokdone
	jp	drawstring
dramokdone
	jp	dotitle

	
	
	
	;; Subroutines

retonly
	ret				; After SRAM test, set up stack, and set ix = retonly


	;; Subroutines that work without the stack
	;; (ix) = return location
	;; Kills a, bc, de, hl
clrscn
	xor	a
	ld	hl,0x4000		; LDIR Source
	ld	(hl),a			; Clear 1st byte 
	ld	de,0x4001		; LDIR Destination
	ld	bc,0x3fff		; LDIR Count 
	ldir
	in	a,(0x10)		; Watchdog 
	jp	(ix)

	
	;; (hl) points to a data table
	;; First 2 bytes = screen loc
	;; String is null-terminated ascii
	;; w/o screen loc, call dstrnoloc

	;; Uses de' for screen loc
	
drawstring
	ld	a,(hl)			; Screen location high byte -> d'
	inc	hl
	exx
	ld	d,a
	exx
	ld	a,(hl)			; Screen location low byte -> e'
	inc	hl
	exx
	ld	e,a

dstrchar	
	exx
dstrnoloc
	in	a,(0x10)		; Watchdog 
	ld	a,(hl)			; Uses HL 
	inc	hl
	and	0xff
	jp	z,dstrend

	exx				
	ld	iy,dstrchardone
	jp	dstdrawchar		 
dstrchardone
	
	ld	bc,0x0050		; 1 column increment 
	ex	de,hl
	add	hl,bc
	ex	de,hl
	jp	dstrchar
	
dstrend
	jp	(ix)


	;;	a = char
	;;	de' = location
	;;      af', bc', and hl' not affected 
drawchar
	exx
dstdrawchar
	sub	0x20			; Assume we're getting good data -- (0x20 - 0x5F only)
	ld	b,0x00			; a here (ax) = character index 
	ld	c,a
	rla
	add	a,c
	ld	c,a			; c = ax * 3 
	ld	hl,chars
	add	hl,bc
	add	hl,bc
	add	hl,bc
	add	hl,bc			; Table index hl = chars + ax * 12 

	ld	b,0x06			; 6*2 bytes per character
drawcharloop
	ld	a,(hl)			; Read byte 
	inc	hl
	ld	(de),a			; Write byte twice (expand mode)
	inc	de
	ld	(de),a
	inc	de
	ld	a,(hl)			; Read byte 
	inc	hl
	ld	(de),a			; Write byte twice (expand mode)
	inc	de
	ld	(de),a
	ld	a,b
	ld	bc,0x004d		; 1 column increment 
	ex	de,hl
	add	hl,bc
	ex	de,hl
	ld	b,a
	djnz	drawcharloop
	jp	(iy)

	
	;;  c = # cycles
	;;  b = # pages
	;; de = start address
ramtest
	ld	a,c
	exx
	ld	c,a
rtloop1
	ld	iy,rtret1
	jp	copyregs
rtret1
	ld	a,c
rtloop2
	add	a,0x2f
	ld	(hl),a
	inc	l
	jp	nz,rtloop2
	inc	a
	inc	h
	djnz	rtloop2
	in	a,(0x10)	; Kick Watchdog 

	ld	iy,rtret2
	jp	copyregs
rtret2
	ld	a,c
rtloop3
	add	a,0x2f
	cp	(hl)
	jr	nz,ramerr
	inc	l
	jp	nz,rtloop3
	inc	a
	inc	h
	djnz	rtloop3
	in	a,(0x10)	; Kick Watchdog 
	dec	c
	jp	nz,rtloop1
	xor	a
	jp	(ix)
ramerr
	xor	(hl)
	jp	(ix)
	
	
	;; hl <-> hl', c <-> c'
copyregs
	exx
	ld	a,h
	exx
	ld	h,a

	exx
	ld	a,l
	exx
	ld	l,a

	exx
	ld	a,b
	exx
	ld	b,a
	
	jp	(iy)

	
	
coltbl
	defb	0x51, 0x7c, 0xf3, 0xc7, 0x00, 0x56, 0x09, 0x9e

title
	defb	0x0e, 0xfc
	defs	"GORF DIAGNOSTICS"
	defb	0x00

version
	defb	0x0c, 0xc8
	defs	"VERSION 2006.08.08"
	defb	0x00

copyrt
	defb	0x0b, 0x84
	defs	"*2006 - MARK SPAETH"
	defb	0x00

email
	defb	0x0d, 0xb0
	defs	"MSPAETH@GMAIL.COM" 
	defb	0x00

sram
	defb	0x06, 0x28
	defs	"PRESS FIRE FOR SRAM TEST"
	defb	0x00

line
	defb	0x01, 0x74
	defs	"----------------------------"
	defb	0x00

sramruns
	defb	0x06, 0x28
	defs	"SRAM TEST IN PROGRESS..."
	defb	0x00

drambadclr
	defb	0x0e, 0xd8
	defs    "                "
	defb	0x00

dram
	defb	0x06, 0x28
	defs	"PRESS FIRE FOR DRAM TEST"
	defb	0x00

sramok
	defb	0x0e, 0xdc
	defs	"SRAM TEST PASSED"
	defb	0x00

dramok
	defb	0x0e, 0xdc
	defs	"DRAM TEST PASSED"
	defb	0x00

srambad
	defb	0x0e, 0xdc
	defs	"SRAM TEST FAILED"
	defb	0x00

srambad2
	defb	0x0f, 0xc8
	defs	"CHECK CHIP: U2"
	defb	0x00

drambad
	defb	0x0e, 0xdc
	defs	"DRAM TEST FAILED"
	defb	0x00

drambad2
	defb	0x0e, 0xd8
	defs	"SLOT -, CHIP U--"		; Slot at 0x19c8, Chip at 0x2D78 
	defb	0x00


	;; Character data stolen from Commander Dave
	;; Thanks Dave!
chars
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	;	0x20
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; !
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; "
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; #
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; 0x
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; %
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; &
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; '
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; (	0x28
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; )
	defb	0x1F, 0xE0, 0x38, 0x70, 0x37, 0xB0, 0x37, 0xB0, 0x3B, 0x70, 0x1F, 0xE0	; * -> Copyright
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; +
	defb	0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00	; ,
	defb	0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00	; -
	defb	0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00	; .
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; /
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x30, 0x30, 0x30, 0x30, 0x3F, 0xF0, 0x1F, 0xE0	; 0	0x30
       	defb	0x00, 0x00, 0x30, 0x20, 0x3F, 0xE0, 0x3F, 0xF0, 0x30, 0x00, 0x00, 0x00	; 1
       	defb	0x3E, 0x60, 0x3F, 0x70, 0x33, 0x30, 0x33, 0x30, 0x33, 0xF0, 0x31, 0xE0	; 2
       	defb	0x18, 0x60, 0x38, 0x70, 0x33, 0x30, 0x33, 0x30, 0x3F, 0xF0, 0x1E, 0xE0	; 3
       	defb	0x03, 0xF0, 0x03, 0xF0, 0x03, 0x00, 0x03, 0x00, 0x3F, 0xF0, 0x3F, 0xF0	; 4
       	defb	0x1B, 0xF0, 0x3B, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0x30, 0x1E, 0x00	; 5
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0x30, 0x1E, 0x00	; 6
       	defb	0x00, 0x30, 0x38, 0x30, 0x3E, 0x30, 0x0F, 0xB0, 0x03, 0xF0, 0x00, 0xF0	; 7
       	defb	0x1E, 0xE0, 0x3F, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0xF0, 0x1E, 0xE0	; 8	0x38
       	defb	0x01, 0xE0, 0x03, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0xF0, 0x1F, 0xE0	; 9
      	defb	0x00, 0x00, 0x18, 0x60, 0x18, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; :	
       	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; ;
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; <
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; =
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; >
	defb	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00	; ?
	defb	0x1F, 0xE0, 0x20, 0x10, 0x21, 0x90, 0x22, 0x50, 0x22, 0x50, 0x13, 0xE0	; @	0x40
       	defb	0x3F, 0xC0, 0x3F, 0xE0, 0x0C, 0x70, 0x0C, 0x70, 0x3F, 0xE0, 0x3F, 0xC0	; A	
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0xF0, 0x1E, 0xE0
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x30, 0x30, 0x30, 0x30, 0x38, 0x70, 0x18, 0x60
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x30, 0x30, 0x30, 0x30, 0x3F, 0xF0, 0x1F, 0xE0
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30, 0x30, 0x30
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x03, 0x30, 0x03, 0x30, 0x03, 0x30, 0x00, 0x30
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x30, 0x30, 0x36, 0x30, 0x3E, 0x30, 0x1E, 0x20  ; G 
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x03, 0x00, 0x03, 0x00, 0x3F, 0xF0, 0x3F, 0xF0	; H	0x48
       	defb	0x00, 0x00, 0x30, 0x30, 0x3F, 0xF0, 0x3F, 0xF0, 0x30, 0x30, 0x00, 0x00
       	defb	0x1C, 0x00, 0x3C, 0x00, 0x30, 0x00, 0x30, 0x00, 0x3F, 0xF0, 0x1F, 0xF0
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x03, 0x80, 0x0F, 0xC0, 0x3C, 0xF0, 0x38, 0x70
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00
       	defb	0x3F, 0xF0, 0x00, 0x60, 0x01, 0x80, 0x01, 0x80, 0x00, 0x60, 0x3F, 0xF0
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x01, 0xC0, 0x03, 0x80, 0x3F, 0xF0, 0x3F, 0xF0
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x30, 0x30, 0x30, 0x30, 0x3F, 0xF0, 0x1F, 0xE0
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x03, 0x30, 0x03, 0x30, 0x03, 0xF0, 0x01, 0xE0	; P	0x50
       	defb	0x1F, 0xE0, 0x3F, 0xF0, 0x20, 0x30, 0x28, 0x30, 0x1F, 0xF0, 0x2F, 0xE0
       	defb	0x3F, 0xF0, 0x3F, 0xF0, 0x03, 0x30, 0x07, 0x30, 0x3F, 0xF0, 0x3D, 0xE0
       	defb	0x19, 0xE0, 0x3B, 0xF0, 0x33, 0x30, 0x33, 0x30, 0x3F, 0x70, 0x1E, 0x60
       	defb	0x00, 0x30, 0x00, 0x30, 0x3F, 0xF0, 0x3F, 0xF0, 0x00, 0x30, 0x00, 0x30
       	defb	0x1F, 0xF0, 0x3F, 0xF0, 0x30, 0x00, 0x30, 0x00, 0x3F, 0xF0, 0x1F, 0xF0
       	defb	0x03, 0xF0, 0x0F, 0xF0, 0x3E, 0x00, 0x3E, 0x00, 0x0F, 0xF0, 0x03, 0xF0
       	defb	0x3F, 0xF0, 0x0C, 0x00, 0x07, 0x80, 0x07, 0x80, 0x0C, 0x00, 0x3F, 0xF0
       	defb	0x38, 0x70, 0x3C, 0xF0, 0x0F, 0xC0, 0x0F, 0xC0, 0x3C, 0xF0, 0x38, 0x70	; X	0x52
       	defb	0x00, 0x70, 0x00, 0xF0, 0x3F, 0xC0, 0x3F, 0xC0, 0x00, 0xF0, 0x00, 0x70
       	defb	0x3C, 0x30, 0x3E, 0x30, 0x37, 0x30, 0x33, 0xB0, 0x31, 0xF0, 0x30, 0xF0	; Z
